﻿//================================================
/*

 Hanukkah Menorah Gadget
 Copyright (c) 2007 Glenn Rivkees.
 http://glennrivkees.com/grplugins/

    This file is part of Hanukkah Gadget.

    Hanukkah Menorah Gadget is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Hanukkah Menorah Gadget is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hanukkah Menorah Gadget; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    To view a copy of this license, visit http://creativecommons.org/licenses/GPL/2.0/

*/
//================================================


function view_onOpen() {
//Check for update when the gadget is open. manualrequest=false.
checkupdate(false);

// Set up menu management handler.
pluginHelper.onAddCustomMenuItems = onAddCustomMenuItems;
}


TargetDate = "12/4/2007 5:30 PM";
//TargetDate = "11/4/2007 2:51 PM";
CountActive = true;
CountStepper = -1;
LeadingZero = true;
DisplayFormat = "%%D%% Days,\n%%H%% Hours,\n%%M%% Minutes,\n%%S%% Seconds.";
FinishMessage = "It's Hanukkah!";

function calcage(secs, num1, num2) {
  s = ((Math.floor(secs/num1))%num2).toString();
  if (LeadingZero && s.length < 2)
    s = "0" + s;
  return "" + s + "";
}

function CountBack(secs) {
  if (secs < 0) {
		debug.trace("runcandles");
		countdown.visible=false;
		cdlabel.visible=false;
		lightcandles();
    return;
  }
  DisplayStr = DisplayFormat.replace(/%%D%%/g, calcage(secs,86400,100000));
  DisplayStr = DisplayStr.replace(/%%H%%/g, calcage(secs,3600,24));
  DisplayStr = DisplayStr.replace(/%%M%%/g, calcage(secs,60,60));
  DisplayStr = DisplayStr.replace(/%%S%%/g, calcage(secs,1,60));

 countdown.innerText = DisplayStr;

  if (CountActive)
    setTimeout("CountBack(" + (secs+CountStepper) + ")", SetTimeOutPeriod);
}


var myDate = new Date;
debug.trace(myDate);
myDate.setHours(myDate.getHours()-17);
myDate.setMinutes(myDate.getMinutes()-30);
debug.trace(myDate);

//day 1
var hanukka07 = new Date;
hanukka07.setSeconds(0);
hanukka07.setMinutes(0);
hanukka07.setHours(0);
hanukka07.setDate(4);
hanukka07.setMonth(11); // January = 0
hanukka07.setFullYear(2007); 

//day 9
var hanukka07end = new Date;
hanukka07end.setSeconds(0);
hanukka07end.setMinutes(0);
hanukka07end.setHours(0);
hanukka07end.setDate(hanukka07.getDate()+8);
hanukka07end.setMonth(11); // January = 0
hanukka07end.setFullYear(2007); 


if(myDate<=hanukka07){

debug.trace("time to 2007");
debug.trace(myDate+" "+hanukka07);
	//count down to it

	CountStepper = Math.ceil(CountStepper);
	if (CountStepper == 0)
		CountActive = false;
	var SetTimeOutPeriod = (Math.abs(CountStepper)-1)*1000 + 990;
	var dthen = new Date(TargetDate);
	var dnow = new Date();
	if(CountStepper>0)
		ddiff = new Date(dnow-dthen);
	else
		ddiff = new Date(dthen-dnow);
	gsecs = Math.floor(ddiff.valueOf()/1000);
		CountBack(gsecs);

}
else if(myDate>=hanukka07end){
debug.trace("time to 2008");
debug.trace(myDate+" "+hanukka07end);
	TargetDate = "12/21/2008 5:30 PM";

	CountStepper = Math.ceil(CountStepper);
	if (CountStepper == 0)
		CountActive = false;
	var SetTimeOutPeriod = (Math.abs(CountStepper)-1)*1000 + 990;
	var dthen = new Date(TargetDate);
	var dnow = new Date();
	if(CountStepper>0)
		ddiff = new Date(dnow-dthen);
	else
		ddiff = new Date(dthen-dnow);
	gsecs = Math.floor(ddiff.valueOf()/1000);
	CountBack(gsecs);
}
else{
	debug.trace("runcandles");
	countdown.visible=false;
	cdlabel.visible=false;
	lightcandles();
}

/*Candles!*/
function lightcandles(){
debug.trace("Candles Lit");
var myDate = new Date;
myDate.setHours(myDate.getHours()-17);
myDate.setMinutes(myDate.getMinutes()-30);
debug.trace(myDate);
	//if we have not started te candles yet. night=1-7.
	//if is night 1
	if (myDate.getDate()==4){
		//set night to 1 and move progress
		//options.putValue("night2007", 1)
		progressbarfunc(1);
		//set new countdown and run timer for next night (thisnight+1)
		setTimeout ( "lightcandles();", 10000 );
	}
	//if is night 2
	else if (myDate.getDate()==5){
		//set night to 1 and move progress
		//options.putValue("night2007", 2)
		progressbarfunc(2);
		//set new countdown and run timer for next night (thisnight+1)
		setTimeout ( "lightcandles();", 10000 );
	}
	//if is night 3
	else if (myDate.getDate()==6){
		//set night to 1 and move progress
		//options.putValue("night2007", 3)
		progressbarfunc(3);
		//set new countdown and run timer for next night (thisnight+1)
		setTimeout ( "lightcandles();", 10000 );
	}
	//if is night 4
	else if (myDate.getDate()==7){
		//set night to 1 and move progress
		//options.putValue("night2007", 4)
		progressbarfunc(4);
		//set new countdown and run timer for next night (thisnight+1)
		setTimeout ( "lightcandles();", 10000 );
	}
	//if is night 5
	else if (myDate.getDate()==8){
		//set night to 1 and move progress
		//options.putValue("night2007", 5)
		progressbarfunc(5);
		//set new countdown and run timer for next night (thisnight+1)
		setTimeout ( "lightcandles();", 10000 );
	}
	//if is night 6
	else if (myDate.getDate()==9){
		//set night to 1 and move progress
		//options.putValue("night2007", 1)
		progressbarfunc(6);
		//set new countdown and run timer for next night (thisnight+1)
		setTimeout ( "lightcandles();", 10000 );
	}
	//if is night 7
	else if (myDate.getDate()==10){
		//set night to 1 and move progress
		//options.putValue("night2007", 1)
		progressbarfunc(7);
		//set new countdown and run timer for next night (thisnight+1)
		setTimeout ( "lightcandles();", 10000 );
	}
	//if night=8
	else if (myDate.getDate()==11){
		//set night to 1 and move progress
		//options.putValue("night2007", 1)
		progressbarfunc(8);
		//set new countdown and run timer for next night (thisnight+1)
		setTimeout ( "lightcandles();", 10000 );
	}
	//if night=9
	else if(myDate.getDate()==12){
		//we're done
		//hide progress
		progressbar1.visible=false;
		progressbar1.value=0;
		countdown.visible=true;
		countdown.innerText="Hope you \nhad a good Hanukka! See you next year!";
	}
}

/*PROGRESS BAR*/
function progressbarfunc(night){
	progressbar1.visible=true
	if(night<=4){
		progressbar1.value = 10 + 9*night
	}
	else if(night>=5){
		progressbar1.value = 55 + 9*(night-4)
	}
}